<template>
  <q-page class="q-pa-lg">
    
    <q-btn :to="{ name: 'community', params: { idCommunity: idCommunity }}" flat class="q-pa-none">
      <q-icon name="arrow_back" size="sm" />
    </q-btn>

    <h1>{{ community }} Stats</h1>
    
    <table>
      <thead>
        <th width="60" align="left">Time</th>
        <th align="left">Total</th>
        <th align="left">Räume</th>
      </thead>
      <tbody>
        <tr v-for="time in times" :key="time.id">
          <td>{{ time.label }}</td>
          <td width="60">{{ time.total }}</td>
          <td style="padding-right:20px;">
            <span v-for="room in getRoomsArray(time.rooms)" :key="room.id">({{ room.label }}: {{ room.counter }})</span>
          </td>
        </tr>
        <tr>
          <td colspan="4"><hr style="margin:0;"></td>
        </tr>
        <tr>
          <td></td>
          <td>{{ total }}</td>
          <td></td>
        </tr>
      </tbody>
    </table>

    <div class="q-my-lg">
      <q-btn @click="pushData()" label="Sync to Church Metrics" :loading="isLoading" size="md" color="red" outline />
    </div>

    <div v-if="showChurchMetricsIds = false">
      <div class="q-mt-xl" v-if="campuses.length">
        <h2>Campuses</h2>
        <div v-for="campus in campuses" :key="campus.id">
          {{ campus.slug }} - {{ campus.id }}
        </div>
      </div>

      <div class="q-mt-xl" v-if="categories.length">
        <h2>Categories</h2>
        <div v-for="category in categories" :key="category.id">
          {{ category.name }} - {{ category.id }}
        </div>
      </div>

      <div class="q-mt-xl" v-if="serviceTimes.length">
        <h2>Service Times</h2>
        <div v-for="serviceTime in serviceTimes" :key="serviceTime.id">
          {{ serviceTime.campus.slug}} - {{ serviceTime.time_of_day }} - {{ serviceTime.id }}
        </div>
      </div>
    </div>

  </q-page>
</template>

<script>
import { defineComponent, ref } from "vue";
import { getDatabase, ref as refFb, onValue } from "firebase/database";
import { useQuasar } from 'quasar';
import { apiChurchMetrics } from 'boot/axios';

export default defineComponent({
  name: "PageTime",
  props: {
    idCommunity: {
      required: true,
    },
  },
  data() {
    return {
      total: 0,
      isLoading: false
    };
  },
  setup() {
    let community = ref("");
    let times = ref([]);
    const $q = useQuasar();

    const campuses = ref([]);
    apiChurchMetrics.get('/campuses.json')
      .then((resp) => {
        campuses.value.push(...resp.data);
      });

    const categories = ref([]);
    apiChurchMetrics.get('/categories.json')
      .then((resp) => {
        categories.value.push(...resp.data);
      });

    let serviceTimes = ref([]);
    apiChurchMetrics.get('/service_times.json')
      .then((resp) => {
        serviceTimes.value.push(...resp.data);
      });


    return {
      community,
      times,
      campuses,
      categories,
      serviceTimes,
    };
  },
  mounted() {
    this.loadCommunity(this.idCommunity);
  },
  async beforeRouteUpdate(to, from) {
    this.loadCommunity(to.params.idCommunity);
  },
  methods: {
    async pushData() {

      var r = confirm("Bist du sicher?!");
      if (r !== true) return;

      this.isLoading = true;

      const successMessage1 = 'Felder erfolgreich übermittelt!';
      const successMessage2 = 'Summe erfolgreich aktualisiert!';
      let hasError1 = false;
      const errorMessage1 = 'Felder bereits übermittelt!';
      
      // 1. Add value to church metrics category fields
      for (let index = 0; index < this.times.length; index++) {
        
        let time = this.times[index];

        try {
          const { data } = await this.writeData(
            {
              campusId: time.churchMetricsCfg.campusId,
              categoryId: time.churchMetricsCfg.categoryId,
              serviceTimeId: time.churchMetricsCfg.serviceTimeId,
              value: time.total + time.churchMetricsCfg.nrVolunteers,
            });
        } catch(error) {
          hasError1 = true;
        }
      }

      if (hasError1) {
        this.$q.notify({
            type: 'warning',
            message: errorMessage1,
            icon: 'warning'
          });
      } else {
        this.$q.notify({
          type: 'positive',
          message: successMessage1,
          icon: 'check_circle'
        });
      }

      // 2. Read all fields of this week
      for (let index = 0; index < this.times.length; index++) {

        let time = this.times[index];

        if (time.churchMetricsCfg.hasOwnProperty('sum')) {
          
          let currentSumObj = null;
          let newSum = 0;

          // Which fields to summarize?
          const sumFieldIds = Object.keys(time.churchMetricsCfg.sum.fields);
          
          // 2.1 Load existing fields
          const { data } = await this.getData(time);

          // 2.2 Sumarize values
          data.forEach((record) => {

            // Sum up available values for sum field
            if (
                record.service_time_id == time.churchMetricsCfg.serviceTimeId &&
                sumFieldIds.includes(record.category.id.toString()
              )) {
              newSum += record.value;
            }

            // Find existing sum field
            if (
                record.service_time_id == time.churchMetricsCfg.serviceTimeId &&
                record.category.id == time.churchMetricsCfg.sum.fieldId
              ) {
              currentSumObj = record;
            }
          });

          // 2.3. Add or update sum field
          if (currentSumObj == null) {

            await this.writeData(
              {
                campusId: time.churchMetricsCfg.campusId,
                categoryId: time.churchMetricsCfg.sum.fieldId,
                serviceTimeId: time.churchMetricsCfg.serviceTimeId,
                value: newSum
              }
            ).then(() => {
              this.$q.notify({
                type: 'positive',
                message: successMessage2,
                icon: 'check_circle'
              });
            })

          } else {

            // BUG in church metrics. CORS response headers are missing.
            // See: https://github.com/lifechurch/churchmetrics-api/issues/40
            await this.updateData(
              {
                record: currentSumObj,
                value: currentSumObj.value + newSum
              }
            ).then((resp) => {
              // console.log(resp);
            })
            .catch((err) => {
              this.$q.notify({
                type: 'warning',
                message: 'Summe bereits vorhanden... Bitte in Church Metrics aktualisieren.',
                icon: 'warning'
              });
            })
          }
        }
      }

      this.isLoading = false;
      return;
    },
    async writeData({ campusId, categoryId, serviceTimeId, value }) {

      const currentDate = new Date();
      const currentDateString = currentDate.toISOString();

      return await apiChurchMetrics.post('/records.json', {
        'campus_id': campusId,
        'category_id': categoryId,
        'service_time_id': serviceTimeId,
        'service_date_time': currentDateString,
        'service_timezone': "Bern",
        'value': value,
        'replaces': true,
      })
    },
    async updateData({ record, value }) {
      return await apiChurchMetrics.put('/records/' + record.id +'.json', {
        'value': value,
      })
    },
    async getData(time) {

      const currentDate = new Date();
      const currentDateString = currentDate.toISOString();

      return await apiChurchMetrics.get('/records.json', { params: {
        'campus_id': time.churchMetricsCfg.campusId,
        'start_time': currentDateString
      }});
    },
    loadCommunity(id) {

      const db = getDatabase();
      
      const starCountRef = refFb(db, "communities/" + id);
      onValue(starCountRef, (snapshot) => {

        const data = snapshot.val();

        this.times = [];
        this.community = data.label;

        Object.keys(data.times).forEach((entry) => {
          
          // console.log(data.times[entry]);
          
          let time = {
            id: entry, 
            label: data.times[entry].label,
            rooms: data.times[entry].rooms,
            total: 0,
            churchMetricsCfg: data.times[entry].churchMetricsCfg
          };

          // Loop rooms and calc values
          for (const [roomKey, value] of Object.entries(data.times[entry].rooms)) {
            time.total += data.times[entry].rooms[roomKey].counter;
          }
          
          this.times.push(time);

          // Sum values for totals
          this.total += time.total;
        });

        // Sort by time label
        this.times.sort((a, b) => a.id > b.id ? 1 : -1);
      });

    },
    getRoomsArray(rooms) {   
      
      let roomsArray = [];
      
      for (const [key, value] of Object.entries(rooms)) {
        roomsArray.push({
          id: key,
          label: value.label,
          counter: value.counter,
          quota: value.quota
        });
      }

      return roomsArray;
    }
  },
});
</script>
